Subject: Re: Excluded List for "#size-cells" warning

From: Segher Boessenkool <[email-masked]>
Date: Wed, 29 Oct 2025 02:29:23 -0500

On Tue, Oct 28, 2025 at 08:17:27PM -0500, Rob Herring wrote:
> On Tue, Oct 28, 2025 at 7:05 PM Stan Johnson <[email-masked]> wrote:
> >
> > -------- Forwarded Message --------
> > Subject: Excluded List for "#size-cells" warning
> > Date: Tue, 28 Oct 2025 10:00:25 -0600
> > From: Stan Johnson <[email-masked]>
> > To: [email-masked]
> > CC: Finn Thain <[email-masked]>, Christophe Leroy
> > <[email-masked]>
> >
> > Hello,
> >
> > On a PowerBook G3 Pismo running the latest Debian SID, dmesg reports the
> > warning shown below. I've also seen the warning on PowerBook Lombard and
> > Wallstreet systems. I haven't checked PowerBook 3400c or Kanga.
> 
> Can you send me a dump of the device tree on these systems:
> 
> dtc -O dts /proc/device-tree
> 
> We've been fixing up these cases such as in commit 7e67ef889c9a
> ("powerpc/prom_init: Fixup missing #size-cells on PowerBook6,7")

And of course it is perfectly fine for an actual Open Firmware to *not*
repeat the defaults.  As the documentation (the main IEEE 1275 thing)
says: "A missing “#size-cells” property signifies the default value of
one."  There are many other places in OF geared towards this default
btw, take for example the "reg" word, that silently assumes your node's
#size-cells is 1, and does completely the wrong thing if not.

Flattened device trees are a fine thing, but the gratuitous ways it
differs from OF, are not.

Segher